#ifndef AES_C
#define AES_C

#include "types.c"
#include "utils.c"

#define WORD_LENGTH 4
#define ROUNDS 10

#define BLOCK_LENGTH 16

typedef enum aes_encryption_mode_t {
  encryption,
  decryption,
} aes_encryption_mode_t;

// --- PRIVATE ---

static uint8_t S_BOX[256] = {
    0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b,
    0xfe, 0xd7, 0xab, 0x76, 0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0,
    0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0, 0xb7, 0xfd, 0x93, 0x26,
    0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15,
    0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2,
    0xeb, 0x27, 0xb2, 0x75, 0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0,
    0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84, 0x53, 0xd1, 0x00, 0xed,
    0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf,
    0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f,
    0x50, 0x3c, 0x9f, 0xa8, 0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5,
    0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2, 0xcd, 0x0c, 0x13, 0xec,
    0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73,
    0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14,
    0xde, 0x5e, 0x0b, 0xdb, 0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c,
    0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79, 0xe7, 0xc8, 0x37, 0x6d,
    0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08,
    0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f,
    0x4b, 0xbd, 0x8b, 0x8a, 0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e,
    0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e, 0xe1, 0xf8, 0x98, 0x11,
    0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf,
    0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f,
    0xb0, 0x54, 0xbb, 0x16,
};

static uint8_t INV_S_BOX[256] = {
    0x52, 0x09, 0x6A, 0xD5, 0x30, 0x36, 0xA5, 0x38, 0xBF, 0x40, 0xA3, 0x9E,
    0x81, 0xF3, 0xD7, 0xFB, 0x7C, 0xE3, 0x39, 0x82, 0x9B, 0x2F, 0xFF, 0x87,
    0x34, 0x8E, 0x43, 0x44, 0xC4, 0xDE, 0xE9, 0xCB, 0x54, 0x7B, 0x94, 0x32,
    0xA6, 0xC2, 0x23, 0x3D, 0xEE, 0x4C, 0x95, 0x0B, 0x42, 0xFA, 0xC3, 0x4E,
    0x08, 0x2E, 0xA1, 0x66, 0x28, 0xD9, 0x24, 0xB2, 0x76, 0x5B, 0xA2, 0x49,
    0x6D, 0x8B, 0xD1, 0x25, 0x72, 0xF8, 0xF6, 0x64, 0x86, 0x68, 0x98, 0x16,
    0xD4, 0xA4, 0x5C, 0xCC, 0x5D, 0x65, 0xB6, 0x92, 0x6C, 0x70, 0x48, 0x50,
    0xFD, 0xED, 0xB9, 0xDA, 0x5E, 0x15, 0x46, 0x57, 0xA7, 0x8D, 0x9D, 0x84,
    0x90, 0xD8, 0xAB, 0x00, 0x8C, 0xBC, 0xD3, 0x0A, 0xF7, 0xE4, 0x58, 0x05,
    0xB8, 0xB3, 0x45, 0x06, 0xD0, 0x2C, 0x1E, 0x8F, 0xCA, 0x3F, 0x0F, 0x02,
    0xC1, 0xAF, 0xBD, 0x03, 0x01, 0x13, 0x8A, 0x6B, 0x3A, 0x91, 0x11, 0x41,
    0x4F, 0x67, 0xDC, 0xEA, 0x97, 0xF2, 0xCF, 0xCE, 0xF0, 0xB4, 0xE6, 0x73,
    0x96, 0xAC, 0x74, 0x22, 0xE7, 0xAD, 0x35, 0x85, 0xE2, 0xF9, 0x37, 0xE8,
    0x1C, 0x75, 0xDF, 0x6E, 0x47, 0xF1, 0x1A, 0x71, 0x1D, 0x29, 0xC5, 0x89,
    0x6F, 0xB7, 0x62, 0x0E, 0xAA, 0x18, 0xBE, 0x1B, 0xFC, 0x56, 0x3E, 0x4B,
    0xC6, 0xD2, 0x79, 0x20, 0x9A, 0xDB, 0xC0, 0xFE, 0x78, 0xCD, 0x5A, 0xF4,
    0x1F, 0xDD, 0xA8, 0x33, 0x88, 0x07, 0xC7, 0x31, 0xB1, 0x12, 0x10, 0x59,
    0x27, 0x80, 0xEC, 0x5F, 0x60, 0x51, 0x7F, 0xA9, 0x19, 0xB5, 0x4A, 0x0D,
    0x2D, 0xE5, 0x7A, 0x9F, 0x93, 0xC9, 0x9C, 0xEF, 0xA0, 0xE0, 0x3B, 0x4D,
    0xAE, 0x2A, 0xF5, 0xB0, 0xC8, 0xEB, 0xBB, 0x3C, 0x83, 0x53, 0x99, 0x61,
    0x17, 0x2B, 0x04, 0x7E, 0xBA, 0x77, 0xD6, 0x26, 0xE1, 0x69, 0x14, 0x63,
    0x55, 0x21, 0x0C, 0x7D,
};

static uint8_t ROUND_CONSTANT[32] = {
    0x00, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1B, 0x36,
    0x6C, 0xD8, 0xAB, 0x4D, 0x9A, 0x2F, 0x5E, 0xBC, 0x63, 0xC6, 0x97,
    0x35, 0x6A, 0xD4, 0xB3, 0x7D, 0xFA, 0xEF, 0xC5, 0x91, 0x39,
};

static size_t aes__block_get(size_t x, size_t y) { return x * 4 + y; }

static uint8_t aes__xtime(uint8_t x) {
  if ((x & 0x80) > 0) {
    return (uint8_t)((x << 1) ^ 0x1B) & 0xFF;
  } else {
    return (uint8_t)(x << 1) & 0xFF;
  }
}

static void aes__shift_rows(uint8_t *block, aes_encryption_mode_t mode) {
  uint8_t *word_original = malloc(sizeof(uint8_t) * WORD_LENGTH);

  for (size_t word_n = 1; word_n < WORD_LENGTH; word_n++) {
    size_t word_start_idx = word_n * WORD_LENGTH;

    for (size_t word_idx = 0; word_idx < WORD_LENGTH; word_idx++) {
      word_original[word_idx] = block[word_start_idx + word_idx];
    }

    for (size_t word_idx = 0; word_idx < WORD_LENGTH; word_idx++) {
      if (mode == encryption) {
        block[word_start_idx + word_idx] =
            word_original[(word_idx + word_n) % WORD_LENGTH];
      } else {
        block[word_start_idx + word_idx] =
            word_original[(word_idx - word_n) % WORD_LENGTH];
      }
    }
  }

  free(word_original);
}

static void aes__mix_words(uint8_t *block, aes_encryption_mode_t mode) {
  if (mode == decryption) {
    for (size_t idx = 0; idx < WORD_LENGTH; idx++) {
      size_t start_idx = aes__block_get(idx, 0);

      uint8_t a =
          aes__xtime(aes__xtime(block[start_idx] ^ block[start_idx + 2]));
      uint8_t b =
          aes__xtime(aes__xtime(block[start_idx + 1] ^ block[start_idx + 3]));

      block[start_idx + 0] ^= a;
      block[start_idx + 2] ^= a;

      block[start_idx + 1] ^= b;
      block[start_idx + 3] ^= b;
    }
  }

  for (size_t idx = 0; idx < WORD_LENGTH; idx++) {
    size_t start_idx = aes__block_get(idx, 0);

    uint8_t xor = block[start_idx] ^ block[start_idx + 1] ^
                  block[start_idx + 2] ^ block[start_idx + 3];

    uint8_t first = block[start_idx];

    for (size_t i = 0; i < 3; i++) {
      block[start_idx + i] ^=
          aes__xtime(block[start_idx + i] ^ block[start_idx + i + 1]) ^ xor;
    }

    block[start_idx + 3] ^= aes__xtime(block[start_idx + 3] ^ first) ^ xor;
  }
}

static void aes__add_round_key(uint8_t *block, uint8_t *round_key) {
  xor_arrays(block, round_key, BLOCK_LENGTH);
}

// NOTE: malloc
static uint8_t *aes__expand_key(uint8_t *key) {
  // Original key + 10 round keys in an array
  size_t round_keys_array_size = (ROUNDS + 1) * BLOCK_LENGTH;
  uint8_t *round_keys =
      (uint8_t *)malloc(sizeof(uint8_t) * round_keys_array_size);
  size_t pos = 0;
  size_t round_constant_idx = 0;

  for (size_t idx = 0; idx < BLOCK_LENGTH; idx++) {
    round_keys[idx] = key[idx];
    pos += 1;
  }

  while (pos < round_keys_array_size) {
    for (size_t idx = 0; idx < WORD_LENGTH; idx++) {
      round_keys[idx + pos] = round_keys[idx + pos - WORD_LENGTH];
    }

    if (pos % BLOCK_LENGTH == 0) {
      uint8_t first = round_keys[pos];
      round_keys[pos] = round_keys[pos + 1];
      round_keys[pos + 1] = round_keys[pos + 2];
      round_keys[pos + 2] = round_keys[pos + 3];
      round_keys[pos + 3] = first;

      for (size_t idx = 0; idx < WORD_LENGTH; idx++) {
        uint8_t value = round_keys[pos + idx];
        round_keys[pos + idx] = S_BOX[value];
      }

      round_keys[pos] = round_keys[round_constant_idx];
      round_constant_idx += 1;
    }

    uint8_t *previous_word = &round_keys[pos];
    uint8_t *modifier_word = &round_keys[pos - BLOCK_LENGTH];
    xor_arrays(previous_word, modifier_word, WORD_LENGTH);
    pos += WORD_LENGTH;
  }

  return round_keys;
}

static void aes__encrypt_block(uint8_t *block, uint8_t *round_keys) {
  aes__add_round_key(block, round_keys);
  for (size_t round = 1; round <= ROUNDS; round++) {
    for (size_t idx = 0; idx < BLOCK_LENGTH; idx++) {
      block[idx] = S_BOX[block[idx]];
    }

    aes__shift_rows(block, encryption);

    if (round != ROUNDS) {
      aes__mix_words(block, encryption);
    }

    aes__add_round_key(block, &round_keys[round * BLOCK_LENGTH]);
  }
}

static void aes__decrypt_block(uint8_t *block, uint8_t *round_keys) {
  for (size_t round = ROUNDS; round >= 1; round--) {
    aes__add_round_key(block, &round_keys[round * BLOCK_LENGTH]);

    if (round != ROUNDS) {
      aes__mix_words(block, decryption);
    }

    aes__shift_rows(block, decryption);

    for (size_t idx = 0; idx < BLOCK_LENGTH; idx++) {
      block[idx] = INV_S_BOX[block[idx]];
    }
  }

  aes__add_round_key(block, round_keys);
}

static bool_t aes__is_valid_padding(uint8_t *block) {
  uint8_t marker = block[BLOCK_LENGTH - 1];

  if (marker == 0) {
    return false;
  }

  for (size_t idx = BLOCK_LENGTH - marker; idx < BLOCK_LENGTH; idx++) {
    if (block[idx] != marker) {
      return false;
    }
  }

  return true;
}

static byte_t *aes__pad_data(byte_t *data, size_t data_length,
                             size_t *out_length) {
  size_t data_length_before_pad = data_length - (data_length % BLOCK_LENGTH);
  size_t marker = BLOCK_LENGTH - (data_length % BLOCK_LENGTH);

  *out_length = data_length_before_pad + BLOCK_LENGTH;
  byte_t *data_padded = malloc(sizeof(byte_t) * (*out_length));

  memset(data_padded, (byte_t)marker, sizeof(byte_t) * (*out_length));
  memcpy(data_padded, data, data_length);

  return data_padded;
}

// --- PUBLIC ---

// Old doesn't work with the new padding scheme
// byte_t *aes_ecb(aes_encryption_mode_t mode, byte_t *data, size_t
// *data_length,
//                 uint8_t *key) {
//   byte_t *data_padded;
//   size_t data_padded_length;

//   // TODO: pad data

//   uint8_t *round_keys = aes__expand_key(key);

//   for (size_t idx = 0; idx < data_padded.data_length_before_pad;
//        idx += BLOCK_LENGTH) {
//     if (mode == encryption) {
//       aes__encrypt_block(&data_padded.data[idx], round_keys);
//     } else {
//       aes__decrypt_block(&data_padded.data[idx], round_keys);
//     }
//   }

//   if (mode == encryption) {
//     aes__encrypt_block(data_padded.padded_block, round_keys);
//   } else {
//     aes__decrypt_block(data_padded.padded_block, round_keys);
//   }

//   free(round_keys);

//   return data_padded.data;
// }

byte_t *aes_cbc(aes_encryption_mode_t mode, byte_t *data, size_t data_length,
                uint8_t *key, size_t *out_data_len) {
  size_t data_padded_length;
  byte_t *data_padded;
  byte_t marker;

  if (mode == encryption) {
    data_padded = aes__pad_data(data, data_length, &data_padded_length);
    marker = data_padded[data_padded_length - 1];
  } else if (mode == decryption) {
    data_padded = malloc(sizeof(byte_t) * data_length);
    memcpy(data_padded, data, data_length);
    data_padded_length = data_length;
  } else {
    return NULL;
  }

  uint8_t *round_keys = aes__expand_key(key);

  // TODO: Derive this properly
  uint8_t *previous_block = malloc(sizeof(uint8_t) * BLOCK_LENGTH * 2);
  for (size_t idx = 0; idx < BLOCK_LENGTH; idx++) {
    previous_block[idx] = 0;
  }

  for (size_t idx = 0; idx < data_padded_length; idx += BLOCK_LENGTH) {
    if (mode == encryption) {
      xor_arrays(&data_padded[idx], previous_block, BLOCK_LENGTH);
      aes__encrypt_block(&data_padded[idx], round_keys);
      clone_array(previous_block, &data_padded[idx], BLOCK_LENGTH);
    } else {
      clone_array(&previous_block[BLOCK_LENGTH], &data_padded[idx],
                  BLOCK_LENGTH);
      aes__decrypt_block(&data_padded[idx], round_keys);
      xor_arrays(&data_padded[idx], previous_block, BLOCK_LENGTH);
      clone_array(previous_block, &previous_block[BLOCK_LENGTH], BLOCK_LENGTH);
    }
  }

  free(previous_block);
  free(round_keys);

  if (mode == encryption) {
    *out_data_len = data_padded_length;
  } else if (mode == decryption &&
             aes__is_valid_padding(
                 &data_padded[data_padded_length - BLOCK_LENGTH])) {
    marker = data_padded[data_padded_length - 1];
    *out_data_len = data_padded_length - marker;
  } else {
    return NULL;
  }
  return data_padded;
}

#endif
